﻿#include "user.h"

u8 display_Num = 0;

u8 common_anode_seg[] = {0xc0,0xf9,0xa4,0xb0,0x99,0x92,0x82,0xf8,0x80,0x90,0x88,0x83,0xc6,0xa1,0x86,0x8e};

u16 CONFIG_SYSTEM_TICK_PERIOD_MS =1;  //配置时钟周期为1ms
//-------------------------------task----------
task_info_t timing_task_array[] =
{
    {0, 100, task_digital_display, 0},    // 显示时钟
    {1, 20, task_matrix_key_detect, 0},      // 按键扫描
    {2, 20, task_key_detect, 0},       // 工作状态显示
	{3, 100, task_I2C_test_sed_data, 0},       // 工作状态显示
//	{4, 1000, task_LED_shine, 0},       // 工作状态显示
	
};
//---------------------------------------------
//------------------------基本配置----------------------------

void IO_config(void)
{
	P2  = 0xFF; 
	
	P1M0 = 0x00; P1M1 = 0x00; 
	P1 = 0xFF;
	P0M0 = 0x00; P0M1 = 0x00; 
	P0 = 0xFF;
    P2M0 = (P2M0 & ~0x03) | 0x18; P2M1 |= 0x1b; 
	P5M0 &= ~0x08; P5M1 &= ~0x08;   //P5.3准双向输出
	P53 =1 ;
}
void Timer0_Init(void)		//1毫秒@11.0592MHz  CONFIG_SYSTEM_TICK_PERIOD_MS =1;  //配置时钟周期为1ms
{
	AUXR |= 0x80;			//定时器时钟1T模式
	TMOD &= 0xF0;			//设置定时器模式
	TL0 = 0xCD;				//设置定时初始值
	TH0 = 0xD4;				//设置定时初始值
	TF0 = 0;				//清除TF0标志
	TR0 = 1;				//定时器0开始计时
	ET0 = 1;				//使能定时器0中断
}


void timing_task_tick(void)
{
    u8 task_index = 0;

    while (task_index < ARRAY_SIZE(timing_task_array))
    {
        timing_task_array[task_index].task_tick_ms += CONFIG_SYSTEM_TICK_PERIOD_MS;     // 每次加一个timer0周期，即 1ms
        task_index++;
    }
}

void timing_task_scheduler(void)
{
    u8 task_index = 0;
        for (task_index = 0 ; task_index < ARRAY_SIZE(timing_task_array); task_index++)
        {
            if (timing_task_array[task_index].task_tick_ms >= timing_task_array[task_index].task_interval)
            {
                timing_task_array[task_index].task_tick_ms = 0;
                timing_task_array[task_index].task_entry();
            }
        }

}

//-----------------task_fun----------------
void task_digital_display (void)
{
	//static uint8_t Num = 0x00;
//	display_Num=I2C_handler0.u8DATA;
	P0  = common_anode_seg[display_Num]; 
}

void task_matrix_key_detect(void)
{
	static u8 scan_Num =0,trigger_Num=0,Down_Up_flag = 0 ;  //Down_Up_flag的按下为1，再抬起为2
	if(scan_Num == 0 )
	{
		//---------------P10下拉--------------------------
		P10= 0; P11=1;P12=1;P13=1;
		scan_Num ++;
		//---------------P14-------------
		if(P14 == 0 & trigger_Num ==0)
		{
			trigger_Num = 0x0F;Down_Up_flag =1;
		}
		if(trigger_Num == 0x0F  & Down_Up_flag ==1 & P14 == 1 ) 
		{
			Down_Up_flag=2;		
		}
		if(trigger_Num == 0x0F & P14 == 1  & Down_Up_flag == 2)
		{
			display_Num =0x0F;
			trigger_Num=0;
			Down_Up_flag=0;
		}
		//--------------------------------
		//------------------P15------------
		if(P15 == 0 & trigger_Num ==0)
		{
			trigger_Num = 0x0C;Down_Up_flag =1;
		}
		if(trigger_Num == 0x0C  & Down_Up_flag ==1 & P15 == 1 ) 
		{
			Down_Up_flag=2;		
		}
		if(trigger_Num == 0x0C & P15 == 1  & Down_Up_flag == 2)
		{
			display_Num =0x0C;
			trigger_Num=0;
			Down_Up_flag=0;
		}
		//--------------------------------
		//------------------P16------------
		if(P16 == 0 & trigger_Num ==0)
		{
			trigger_Num = 0x08;Down_Up_flag =1;
		}
		if(trigger_Num == 0x08  & Down_Up_flag ==1 & P16 == 1 ) 
		{
			Down_Up_flag=2;		
		}
		if(trigger_Num == 0x08 & P16 == 1  & Down_Up_flag == 2)
		{
			display_Num =0x08;
			trigger_Num=0;
			Down_Up_flag=0;
		}
		//--------------------------------
		//------------------P17------------
		if(P17 == 0 & trigger_Num ==0)
		{
			trigger_Num = 0x04;Down_Up_flag =1;
		}
		if(trigger_Num == 0x04  & Down_Up_flag ==1 & P17 == 1 ) 
		{
			Down_Up_flag=2;		
		}
		if(trigger_Num == 0x04 & P17 == 1  & Down_Up_flag == 2)
		{
			display_Num =0x04;
			trigger_Num=0;
			Down_Up_flag=0;
		}
	}
	else if(scan_Num==1)
	{
		P10= 1; P11=0;P12=1;P13=1;
		scan_Num++;
	}
	else if(scan_Num==2)
	{
		P10= 1; P11=1;P12=0;P13=1;
		scan_Num++;
	}
	else if(scan_Num==3)
	{
		P10= 1; P11=1;P12=1;P13=0;
		scan_Num=0;
	}
	//----------------------P10---------------
	
	//---------------------------------------------
	//---------------------------------P11=0-------
	if(P11==0)
	{
		//---------------P14-------------
		if(P14 == 0 & trigger_Num ==0)
		{
			trigger_Num = 0x0E;Down_Up_flag =1;
		}
		if(trigger_Num == 0x0E  & Down_Up_flag ==1 & P14 == 1 ) 
		{
			Down_Up_flag=2;		
		}
		if(trigger_Num == 0x0E & P14 == 1  & Down_Up_flag == 2)
		{
			display_Num =0x0E;
			trigger_Num=0;
			Down_Up_flag=0;
		}
		//--------------------------------
	}
	
}

void task_key_detect(void)
{
	if (P30 ==0)
	{
		display_Num = 0;
	}
}
//-----------------------------------------
//-------------------I2C测试----------------------
void task_I2C_test_sed_data(void)
{

	

}

void task_LED_shine (void)
{
	P53 =~P53;
}


