﻿#ifndef _USER_H
#define _USER_H

#include "AI8051U.H"
#include "intrins.h"
#include "ureg.h"

// 任务结构
typedef struct {
    u8 task_id;                  // 任务 ID
    u16 task_interval;             // 任务运行间隔时间
    void (*task_entry)(void);           // 要运行的任务
    volatile u16 task_tick_ms;     // 计时器
}task_info_t;

//----------------------------------extern---------------
extern u8 display_Num;
extern u8 common_anode_seg[];
extern u16 CONFIG_SYSTEM_TICK_PERIOD_MS;
extern task_info_t timing_task_array[];
//-------------------------------------------------------
void IO_config(void);
void Timer0_Init(void)	;	//1毫秒@11.0592MHz
void timing_task_tick(void);
void timing_task_scheduler(void);
void task_digital_display (void);
void task_matrix_key_detect(void);
void task_key_detect(void);
void task_I2C_test_sed_data(void);
void task_LED_shine (void);

#endif /*_USER_H*/
